[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Annotation of openbsd/fw_update/fw_install.sh, Revision 1.134

1.1       afresh1     1: #!/bin/ksh
1.36      afresh1     2: #      $OpenBSD$
1.50      afresh1     3: #
1.38      afresh1     4: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17:
1.95      afresh1    18: set -o errexit -o pipefail -o nounset -o noclobber -o noglob
1.85      afresh1    19: set +o monitor
1.77      afresh1    20: export PATH=/usr/bin:/bin:/usr/sbin:/sbin
1.50      afresh1    21:
                     22: CFILE=SHA256.sig
                     23: DESTDIR=${DESTDIR:-}
                     24: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
                     25:
                     26: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
                     27: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
                     28:
                     29: HTTP_FWDIR="$VNAME"
1.52      afresh1    30: VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
                     31:     /var/run/dmesg.boot | sed '$!d' )
1.50      afresh1    32: [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
1.22      afresh1    33:
1.50      afresh1    34: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
                     35: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.8       afresh1    36:
1.131     afresh1    37: DRYRUN=false
1.97      afresh1    38: VERBOSE=false
1.111     afresh1    39: DELETE=false
1.87      afresh1    40: DOWNLOAD=true
                     41: INSTALL=true
1.69      afresh1    42: LOCALSRC=
                     43:
1.126     afresh1    44: unset FTPPID
1.129     afresh1    45: unset FWPKGTMP
1.126     afresh1    46: REMOVE_LOCALSRC=false
                     47: cleanup() {
1.127     afresh1    48:        set +o errexit # ignore errors from killing ftp
1.128     afresh1    49:        [ "${FTPPID:-}" ] && kill -TERM -"$FTPPID" 2>/dev/null
1.129     afresh1    50:        [ "${FWPKGTMP:-}" ] && rm -rf "$FWPKGTMP"
1.126     afresh1    51:        "$REMOVE_LOCALSRC" && rm -rf "$LOCALSRC"
                     52: }
                     53: trap cleanup EXIT
                     54:
1.8       afresh1    55: tmpdir() {
                     56:        local _i=1 _dir
                     57:
1.50      afresh1    58:        # If we're not in the installer,
1.79      afresh1    59:        # we have mktemp and a more hostile environment.
1.50      afresh1    60:        if [ -x /usr/bin/mktemp ]; then
                     61:                _dir=$( mktemp -d "${1}-XXXXXXXXX" )
1.44      afresh1    62:        else
1.50      afresh1    63:                until _dir="${1}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44      afresh1    64:                    ((++_i < 10000)) || return 1
                     65:                done
                     66:        fi
1.50      afresh1    67:
1.8       afresh1    68:        echo "$_dir"
                     69: }
1.6       afresh1    70:
1.50      afresh1    71: fetch() {
1.126     afresh1    72:        local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit _error=''
1.6       afresh1    73:
1.79      afresh1    74:        # If we're not in the installer,
                     75:        # we have su(1) and doas(1) is unlikely to be configured.
1.85      afresh1    76:        set -o monitor # make sure ftp gets its own process group
                     77:        (
1.101     afresh1    78:        flags=-VM
                     79:        "$VERBOSE" && flags=-vm
1.53      afresh1    80:        if [ -x /usr/bin/su ]; then
1.85      afresh1    81:                exec /usr/bin/su -s /bin/ksh "$_user" -c \
1.119     afresh1    82:                    "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"
1.42      afresh1    83:        else
1.85      afresh1    84:                exec /usr/bin/doas -u "$_user" \
1.119     afresh1    85:                    /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $flags -o- "$_src" > "$_dst"
1.42      afresh1    86:        fi
1.126     afresh1    87:        ) & FTPPID=$!
1.85      afresh1    88:        set +o monitor
                     89:
                     90:        SECONDS=0
                     91:        _last=0
1.126     afresh1    92:        while kill -0 -"$FTPPID" 2>/dev/null; do
1.85      afresh1    93:                if [[ $SECONDS -gt 12 ]]; then
                     94:                        set -- $( ls -ln "$_dst" 2>/dev/null )
                     95:                        if [[ $_last -ne $5 ]]; then
                     96:                                _last=$5
                     97:                                SECONDS=0
                     98:                                sleep 1
                     99:                        else
1.126     afresh1   100:                                kill -INT -"$FTPPID"
1.92      afresh1   101:                                _error=" (timed out)"
1.85      afresh1   102:                        fi
                    103:                else
                    104:                        sleep 1
                    105:                fi
                    106:        done
                    107:
                    108:        set +o errexit
1.126     afresh1   109:        wait "$FTPPID"
1.85      afresh1   110:        _exit=$?
                    111:        set -o errexit
                    112:
1.126     afresh1   113:        unset FTPPID
1.6       afresh1   114:
1.50      afresh1   115:        if [ "$_exit" -ne 0 ]; then
1.69      afresh1   116:                rm -f "$_dst"
1.92      afresh1   117:                echo "Cannot fetch $_src$_error" >&2
1.50      afresh1   118:                return 1
                    119:        fi
1.6       afresh1   120: }
                    121:
1.50      afresh1   122: verify() {
                    123:        # On the installer we don't get sha256 -C, so fake it.
1.69      afresh1   124:        if ! fgrep -qx "SHA256 (${1##*/}) = $( /bin/sha256 -qb "$1" )" "$CFILE"; then
                    125:                echo "Checksum test for ${1##*/} failed." >&2
1.50      afresh1   126:                return 1
                    127:        fi
1.6       afresh1   128: }
                    129:
1.124     afresh1   130: firmware_in_dmesg() {
1.90      afresh1   131:        local _d _m _line _dmesgtail _last='' _nl=$( echo )
1.1       afresh1   132:
1.50      afresh1   133:        # When we're not in the installer, the dmesg.boot can
                    134:        # contain multiple boots, so only look in the last one
1.133     afresh1   135:        _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )"
1.50      afresh1   136:
1.89      afresh1   137:        grep -v '^[[:space:]]*#' "$FWPATTERNS" |
                    138:            while read -r _d _m; do
                    139:                [ "$_d" = "$_last" ] && continue
1.90      afresh1   140:                [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                    141:                [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
1.83      afresh1   142:
1.89      afresh1   143:                if [[ $_dmesgtail = *$_m* ]]; then
                    144:                        echo "$_d"
                    145:                        _last="$_d"
                    146:                fi
                    147:            done
1.50      afresh1   148: }
1.14      afresh1   149:
1.50      afresh1   150: firmware_filename() {
1.56      afresh1   151:        local _f
                    152:        _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
                    153:        ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
                    154:        echo "$_f"
1.50      afresh1   155: }
1.7       afresh1   156:
1.57      afresh1   157: firmware_devicename() {
                    158:        local _d="${1##*/}"
                    159:        _d="${_d%-firmware-*}"
                    160:        echo "$_d"
                    161: }
                    162:
1.50      afresh1   163: installed_firmware() {
1.110     afresh1   164:        local _pre="$1" _match="$2" _post="$3" _firmware
1.123     afresh1   165:        set -sA _firmware -- $(
1.109     afresh1   166:            set +o noglob
                    167:            grep -Fxl '@option firmware' \
1.110     afresh1   168:                "${DESTDIR}/var/db/pkg/"$_pre"$_match"$_post"/+CONTENTS" \
1.109     afresh1   169:                2>/dev/null || true
                    170:            set -o noglob
                    171:        )
                    172:
                    173:        [ "${_firmware[*]:-}" ] || return 0
                    174:        for fw in "${_firmware[@]}"; do
                    175:                fw="${fw%/+CONTENTS}"
1.50      afresh1   176:                echo "${fw##*/}"
                    177:        done
                    178: }
1.1       afresh1   179:
1.124     afresh1   180: detect_firmware() {
                    181:        local _devices _last='' _d
                    182:
                    183:        set -sA _devices -- $(
                    184:            firmware_in_dmesg
                    185:            for _d in $( installed_firmware '*' '-firmware-' '*' ); do
                    186:                echo "$( firmware_devicename "$_d" )"
                    187:            done
                    188:        )
                    189:
                    190:        [ "${_devices[*]:-}" ] || return 0
                    191:        for _d in "${_devices[@]}"; do
                    192:                [[ $_last = $_d ]] && continue
                    193:                echo $_d
                    194:                _last="$_d"
                    195:        done
                    196: }
                    197:
1.50      afresh1   198: add_firmware () {
1.106     afresh1   199:        local _f="${1##*/}" _pkgname
1.129     afresh1   200:        FWPKGTMP="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
1.101     afresh1   201:        local flags=-VM
                    202:        "$VERBOSE" && flags=-vm
1.119     afresh1   203:        ftp -N "${0##/}" -D "Install" "$flags" -o- "file:${1}" |
1.129     afresh1   204:                tar -s ",^\+,${FWPKGTMP}/+," \
1.69      afresh1   205:                    -s ",^firmware,${DESTDIR}/etc/firmware," \
                    206:                    -C / -zxphf - "+*" "firmware/*"
1.1       afresh1   207:
1.129     afresh1   208:        _pkgname="$( sed -n '/^@name /{s///p;q;}' "${FWPKGTMP}/+CONTENTS" )"
1.106     afresh1   209:        if [ ! "$_pkgname" ]; then
                    210:                echo "Failed to extract name from $1, partial install" 2>&1
1.129     afresh1   211:                rm -rf "$FWPKGTMP"
                    212:                unset FWPKGTMP
1.106     afresh1   213:                return 1
                    214:        fi
                    215:
1.50      afresh1   216:        # TODO: Should we mark these so real fw_update can -Drepair?
1.129     afresh1   217:        ed -s "${FWPKGTMP}/+CONTENTS" <<EOL
1.50      afresh1   218: /^@comment pkgpath/ -1a
                    219: @option manual-installation
                    220: @option firmware
                    221: @comment install-script
                    222: .
                    223: w
                    224: EOL
1.106     afresh1   225:
1.129     afresh1   226:        chmod 755 "$FWPKGTMP"
                    227:        mv "$FWPKGTMP" "${DESTDIR}/var/db/pkg/${_pkgname}"
                    228:        unset FWPKGTMP
1.50      afresh1   229: }
1.22      afresh1   230:
1.50      afresh1   231: delete_firmware() {
1.51      afresh1   232:        local _cwd _pkg="$1" _pkgdir="${DESTDIR}/var/db/pkg"
1.22      afresh1   233:
1.50      afresh1   234:        # TODO: Check hash for files before deleting
1.101     afresh1   235:        "$VERBOSE" && echo "Uninstalling $_pkg"
1.51      afresh1   236:        _cwd="${_pkgdir}/$_pkg"
1.50      afresh1   237:
1.107     afresh1   238:        if [ ! -e "$_cwd/+CONTENTS" ] ||
                    239:            ! grep -Fxq '@option firmware' "$_cwd/+CONTENTS"; then
                    240:                echo "${0##*/}: $_pkg does not appear to be firmware" >&2
                    241:                return 2
                    242:        fi
                    243:
1.51      afresh1   244:        set -A _remove -- "${_cwd}/+CONTENTS" "${_cwd}"
1.50      afresh1   245:
                    246:        while read -r c g; do
                    247:                case $c in
1.51      afresh1   248:                @cwd) _cwd="${DESTDIR}$g"
1.50      afresh1   249:                  ;;
                    250:                @*) continue
                    251:                  ;;
1.52      afresh1   252:                *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
1.50      afresh1   253:                  ;;
                    254:                esac
                    255:        done < "${_pkgdir}/${_pkg}/+CONTENTS"
                    256:
                    257:        # We specifically rm -f here because not removing files/dirs
                    258:        # is probably not worth failing over.
                    259:        for _r in "${_remove[@]}" ; do
                    260:                if [ -d "$_r" ]; then
                    261:                        # Try hard not to actually remove recursively
                    262:                        # without rmdir on the install media.
1.95      afresh1   263:                        set +o noglob
1.50      afresh1   264:                        [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
1.95      afresh1   265:                        set -o noglob
1.50      afresh1   266:                else
                    267:                        rm -f "$_r"
1.22      afresh1   268:                fi
                    269:        done
1.50      afresh1   270: }
1.1       afresh1   271:
1.59      afresh1   272: usage() {
1.122     afresh1   273:        echo "usage:  ${0##*/} [-d | -D] [-av] [-p path] [driver | file ...]"
1.59      afresh1   274:        exit 2
                    275: }
                    276:
1.113     afresh1   277: ALL=false
1.87      afresh1   278: OPT_D=
1.131     afresh1   279: while getopts :adDnp:v name
1.59      afresh1   280: do
                    281:        case "$name" in
1.113     afresh1   282:        a) ALL=true ;;
1.111     afresh1   283:        d) DELETE=true ;;
1.87      afresh1   284:        D) OPT_D=true ;;
1.131     afresh1   285:        n) DRYRUN=true ;;
1.121     afresh1   286:        p) LOCALSRC="$OPTARG" ;;
1.97      afresh1   287:        v) VERBOSE=true ;;
1.121     afresh1   288:        :)
                    289:           echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
                    290:           usage 2
                    291:           ;;
                    292:        ?)
                    293:           echo "${0##*/}: unknown option -- -$OPTARG" >&2
                    294:           usage 2
                    295:           ;;
1.59      afresh1   296:        esac
                    297: done
                    298: shift $((OPTIND - 1))
                    299:
1.121     afresh1   300: if [ "$LOCALSRC" ]; then
                    301:        if [[ $LOCALSRC = @(ftp|http?(s))://* ]]; then
                    302:                FWURL="${LOCALSRC}"
                    303:                LOCALSRC=
                    304:        else
                    305:                LOCALSRC="${LOCALSRC:#file:}"
                    306:                ! [ -d "$LOCALSRC" ] &&
                    307:                    echo "The path must be a URL or an existing directory" >&2 &&
                    308:                    exit 2
                    309:        fi
                    310: fi
                    311:
1.122     afresh1   312: # "Download only" means local dir and don't install
1.87      afresh1   313: if [ "$OPT_D" ]; then
                    314:        INSTALL=false
1.121     afresh1   315:        LOCALSRC="${LOCALSRC:-.}"
1.130     afresh1   316: elif [ "$LOCALSRC" ]; then
                    317:        DOWNLOAD=false
1.87      afresh1   318: fi
1.64      afresh1   319:
1.118     afresh1   320: if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
                    321:        echo "need root privileges" >&2
                    322:        exit 1
1.94      afresh1   323: fi
                    324:
1.123     afresh1   325: set -sA devices -- "$@"
1.111     afresh1   326:
                    327: if "$DELETE"; then
1.122     afresh1   328:        [ "$OPT_D" ] && usage 22
1.111     afresh1   329:
1.113     afresh1   330:        set -A installed
                    331:        if [ "${devices[*]:-}" ]; then
                    332:                "$ALL" && usage 22
                    333:
                    334:                set -A installed -- $(
                    335:                    for d in "${devices[@]}"; do
                    336:                        f="${d##*/}"  # only care about the name
                    337:                        f="${f%.tgz}" # allow specifying the package name
                    338:                        [ "$( firmware_devicename "$f" )" = "$f" ] && f="$f-firmware"
                    339:
                    340:                        set -A i -- $( installed_firmware '' "$f-" '*' )
                    341:
                    342:                        if [ "${i[*]:-}" ]; then
                    343:                                echo "${i[@]}"
                    344:                        else
                    345:                                echo "No firmware found for '$d'" >&2
                    346:                        fi
                    347:                    done
                    348:                )
                    349:        elif "$ALL"; then
                    350:                set -A installed -- $( installed_firmware '*' '-firmware-' '*' )
                    351:        fi
1.111     afresh1   352:
                    353:        deleted=''
1.113     afresh1   354:        if [ "${installed:-}" ]; then
1.111     afresh1   355:                for fw in "${installed[@]}"; do
1.131     afresh1   356:                        if "$DRYRUN"; then
                    357:                                echo "Delete $fw"
                    358:                        else
                    359:                                delete_firmware "$fw" || continue
                    360:                        fi
1.112     afresh1   361:                        deleted="$deleted,$( firmware_devicename "$fw" )"
1.111     afresh1   362:                done
1.113     afresh1   363:        fi
1.111     afresh1   364:
                    365:        deleted="${deleted:+${deleted#,}}"
                    366:        echo "${0:##*/}: deleted ${deleted:-none}";
                    367:
                    368:        exit
                    369: fi
1.125     afresh1   370:
                    371: if [ ! "$LOCALSRC" ]; then
                    372:     LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
1.126     afresh1   373:     REMOVE_LOCALSRC=true
1.125     afresh1   374: fi
                    375:
                    376: CFILE="$LOCALSRC/$CFILE"
1.58      afresh1   377:
1.113     afresh1   378: if [ "${devices[*]:-}" ]; then
                    379:        "$ALL" && usage 22
                    380: else
1.101     afresh1   381:        "$VERBOSE" && echo -n "Detecting firmware ..."
1.124     afresh1   382:        set -sA devices -- $( detect_firmware )
1.101     afresh1   383:        "$VERBOSE" &&
                    384:            { [ "${devices[*]:-}" ] && echo " found." || echo " done." ; }
1.50      afresh1   385: fi
1.91      afresh1   386:
                    387: [ "${devices[*]:-}" ] || exit
1.50      afresh1   388:
1.71      afresh1   389: if "$DOWNLOAD"; then
1.116     afresh1   390:        set +o noclobber # we want to get the latest CFILE
1.64      afresh1   391:        fetch "$CFILE"
1.116     afresh1   392:        set -o noclobber
1.64      afresh1   393:        ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
                    394:            echo "Signature check of SHA256.sig failed" >&2 && exit 1
1.120     afresh1   395: elif [ ! -e "$CFILE" ]; then
                    396:        # TODO: We shouldn't need a CFILE if all arguments are files.
                    397:        echo "${0##*/}: $CFILE: No such file or directory" >&2
                    398:        exit 2
1.64      afresh1   399: fi
1.50      afresh1   400:
1.103     afresh1   401: added=''
                    402: updated=''
1.115     afresh1   403: kept=''
1.70      afresh1   404: for f in "${devices[@]}"; do
                    405:        d="$( firmware_devicename "$f" )"
                    406:
1.58      afresh1   407:        if [ "$f" = "$d" ]; then
                    408:                f=$( firmware_filename "$d" || true )
                    409:                [ "$f" ] || continue
1.69      afresh1   410:                f="$LOCALSRC/$f"
1.76      afresh1   411:        elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
1.70      afresh1   412:                echo "Cannot download local file $f" >&2
                    413:                exit 2
1.58      afresh1   414:        fi
                    415:
1.110     afresh1   416:        set -A installed -- $( installed_firmware '' "$d-firmware-" '*' )
1.50      afresh1   417:
1.68      afresh1   418:        if "$INSTALL" && [ "${installed[*]:-}" ]; then
1.65      afresh1   419:                for i in "${installed[@]}"; do
1.58      afresh1   420:                        if [ "${f##*/}" = "$i.tgz" ]; then
1.131     afresh1   421:                                "$VERBOSE" && echo "Keep $i"
1.115     afresh1   422:                                kept="$kept,$d"
1.11      afresh1   423:                                continue 2
1.1       afresh1   424:                        fi
                    425:                done
1.50      afresh1   426:        fi
1.1       afresh1   427:
1.72      afresh1   428:        if [ -e "$f" ]; then
                    429:                if "$DOWNLOAD"; then
1.134   ! afresh1   430:                        "$VERBOSE" && ! "$INSTALL" &&
        !           431:                            echo "Keep/Verify ${f##*/}"
1.131     afresh1   432:                        "$DRYRUN"  || verify "$f" || continue
                    433:                        "$INSTALL" || kept="$kept,$d"
1.72      afresh1   434:                # else assume it was verified when downloaded
                    435:                fi
1.75      afresh1   436:        elif "$DOWNLOAD"; then
1.131     afresh1   437:                if "$DRYRUN"; then
                    438:                        "$VERBOSE" && echo "Get/Verify ${f##*/}"
                    439:                else
                    440:                        fetch  "$f" || continue
                    441:                        verify "$f" || continue
                    442:                fi
1.117     afresh1   443:                "$INSTALL"  || added="$added,$d"
1.75      afresh1   444:        elif "$INSTALL"; then
1.72      afresh1   445:                echo "Cannot install ${f##*/}, not found" >&2
                    446:                continue
1.58      afresh1   447:        fi
1.60      afresh1   448:
1.68      afresh1   449:        "$INSTALL" || continue
1.11      afresh1   450:
1.103     afresh1   451:        removed=false
1.65      afresh1   452:        if [ "${installed[*]:-}" ]; then
1.50      afresh1   453:                for i in "${installed[@]}"; do
1.131     afresh1   454:                        "$DRYRUN" || delete_firmware "$i"
1.103     afresh1   455:                        removed=true
1.50      afresh1   456:                done
                    457:        fi
1.11      afresh1   458:
1.131     afresh1   459:        "$DRYRUN" || add_firmware "$f"
1.103     afresh1   460:
1.131     afresh1   461:        f="${f##*/}"
                    462:        f="${f%.tgz}"
1.103     afresh1   463:        if "$removed"; then
1.131     afresh1   464:                "$DRYRUN" && echo "Update $f"
1.114     afresh1   465:                updated="$updated,$d"
1.103     afresh1   466:        else
1.131     afresh1   467:                "$DRYRUN" && echo "Install $f"
1.114     afresh1   468:                added="$added,$d"
1.103     afresh1   469:        fi
1.50      afresh1   470: done
1.1       afresh1   471:
1.114     afresh1   472: added="${added:#,}"
                    473: updated="${updated:#,}"
1.115     afresh1   474: kept="${kept:#,}"
1.117     afresh1   475: if "$INSTALL"; then
                    476:        echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
                    477: else
                    478:        echo  "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
                    479: fi

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>